// robowaifu access control
// ========================
// -The software testbed for devising access control systems for robowaifus

// -Filename: Human.hpp
// -The declarations interface of the Human class

// TODO DOC: Add exposition for Anon as a learner, to understand why & how
// Human objects are used in this system.

#pragma once

#include <memory>
#include <string>

#include "utility.hpp"

using std::string;

/** Represents a Human entity within robowaifu's model-of-the-world, with the
 * associated name & container of Relation's (Groups) embedded within */
class Human {
 public:
  Human(){};
  /** Basic Human ctor
   * @param name [IN] the common name for the Human
   * @param groups [IN] the container of Relation's the Human is within
   */
  Human(std::string const& name, Groups const& groups);

  /** @return the Human's common name */
  auto human() const noexcept -> decltype(std::string{});

  /** @return the Human's container of Relation's to robowaifu's Master */
  auto relations() const noexcept -> decltype(Groups{});

 private:
  string name;
  Groups groups;
};

namespace rw {

/** The one (and @b only one) robowaifu's Master */
static std::unique_ptr<Human> The_Master = nullptr;

}  // namespace rw

// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
