// robowaifu access control
// ========================
// -The software testbed for devising access control systems for robowaifus

// -Filename: Inquiry.hpp
// -The declarations interface of the Inquiry class

// TODO DOC: Add exposition for Anon as a learner, to understand why & how
// Inquiry objects are used in this system.

#pragma once

#include "Human.hpp"
#include "Info.hpp"
#include "utility.hpp"

/** Represents an information request within robowaifu's model-of-the-world,
 * with the associated Human 'asker' & Info data objects embedded within */
class Inquiry {
 public:
  Inquiry(){};
  /** Basic Inquiry ctor
   * @param human [IN] the Human asking the question
   * @param info [IN] the Info being requested
   */
  Inquiry(Human const& human, Info const& info);

  // TODO DESIGN: add non-Human inquirers (robowaifus, systems, etc.) ctor

  /** @return the Inquiry's Human 'asker' */
  auto who() const noexcept -> decltype(Human{});

  /** @return the Inquiry's Info item */
  auto what() const noexcept -> decltype(Info{});

 private:
  Human human;
  Info  info;
};

// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
